<?php

namespace Ems\Services;

use Util\Environment;
use Ems\Repository\FormacaoRepository;
use Util\NovoCodigo;

class FormacaoService {
    /** @var Environment */
    protected $environment;

    /** @var FormacaoRepository */
    protected $formacaoRepository;

    public function __construct(
        Environment         $environment,
        FormacaoRepository  $formacaoRepository
    ) {
        $this->environment          = $environment;
        $this->formacaoRepository   = $formacaoRepository;
    }

    public function setFormacaoParc(
        array $row
    ): int {
        $nrOrg = (int) $this->environment->getNrOrg();
        $params = [];

        $params['NRFORMACAO'] =
            $row['NRFORMACAO'] ??
            NovoCodigo::geraCodigo($nrOrg, 'DES_FORMACAO', 1, 12, true, false);

        $params['NRORG']                    = $row['NRORG'] ?? $nrOrg;
        $params['NRPARCNEGOCIO']            = $row['NRPARCNEGOCIO'] ?? null;
        $params['CDSTATUS']                 = $row['CDSTATUS'] ?? null;
        $params['DTINICIO']                 = $row['DTINICIO'] ?? null;
        $params['DTFIM']                    = $row['DTFIM'] ?? null;
        $params['NRCARGAHORARIA']           = $row['NRCARGAHORARIA'] ?? null;
        $params['NRAREAFORMACAO']           = $row['NRAREAFORMACAO'] ?? null;
        $params['NRCURSO']                  = $row['NRCURSO'] ?? null;
        $params['DSCURSO']                  = $row['DSCURSO'] ?? null;
        $params['NRGRAUCONFERIDO']          = $row['NRGRAUCONFERIDO'] ?? null;
        $params['NRINSTITUICAOPARC']        = $row['NRINSTITUICAOPARC'] ?? null;
        $params['DSINSTITUICAO']            = $row['DSINSTITUICAO'] ?? null;
        $params['DSOBSERVACAO']             = $row['DSOBSERVACAO'] ?? null;
        $params['DTINCLUSAO']               = $row['DTINCLUSAO'] ?? date('d/m/Y');
        $params['DTULTATU']                 = $row['DTULTATU'] ?? null;
        $params['NRORGINCLUSAO']            = $row['NRORGINCLUSAO'] ?? $nrOrg;
        $params['CDOPERINCLUSAO']           = $row['CDOPERINCLUSAO'] ?? 1;
        $params['NRORGULTATU']              = $row['NRORGULTATU'] ?? null;
        $params['CDOPERULTATU']             = $row['CDOPERULTATU'] ?? null;
        $params['DES_AREAFORMACAO_NRORG']   = $row['DES_AREAFORMACAO_NRORG'] ?? null;
        $params['NRTIPOFORMACAO']           = $row['NRTIPOFORMACAO'] ?? null;
        $params['CDIDIOMA']                 = $row['CDIDIOMA'] ?? null;
        $params['IDNVIDIOMA']               = $row['IDNVIDIOMA'] ?? null;
        $params['NRPERIODO']                = $row['NRPERIODO'] ?? null;
        $params['NRESTRUTURAM']             = $row['NRESTRUTURAM'] ?? null;
        $params['DSANDAMENTOCURSO']         = $row['DSANDAMENTOCURSO'] ?? null;

        $this->formacaoRepository->setFormacaoParc($params);

        return $params['NRFORMACAO'];
    }
}