/* ----------------------------------------------------------------------------------- */
/* Objetivo: Inativar os clientes inadimplentes, conforme titulos em atraso, de acordo */
/* com a quantidade de dias parametrizados na tela Titulos em Atraso                   */
/* para inativar o cliente, a quantidade de dias para inativar deve ser maior que zero */
/* esta procedure  executada atravs de JOB, criados especificamente para cada cliente*/
/* o primeiro cliente utilizar esta rotina  a Sapore (0035)                           */
/* ----------------------------------------------------------------------------------- */
CREATE OR REPLACE PROCEDURE VERIFICA_INADIMPLENCIA
AS
   V_QTDIAS NUMBER;
BEGIN

   V_QTDIAS := 0;

   SELECT NVL(QTDIASINATCLI,0)
     INTO V_QTDIAS
     FROM PARAMGERAL;   

   IF V_QTDIAS > 0 THEN
      FOR C_CLIENTE_INAD IN (SELECT DISTINCT CL.CDCLIENTE
                               FROM NOTAFISCAL NF, CONTARECEBER CR, CLIENTE CL
                              WHERE NF.CDFILIAL   = CR.CDFILIAL
                                AND NF.NRLANCTONF = CR.NRLANCTONF
                                AND NF.CDCLIENTE  = CL.CDCLIENTE
                                AND (TRUNC(SYSDATE) - CR.DTATUAVENREC) BETWEEN V_QTDIAS AND V_QTDIAS + (TRUNC(SYSDATE) - CR.DTATUAVENREC)
                                AND NF.IDSTATUS IN ('A','E')
                                AND CR.IDSTATREC <> 'B') LOOP

         UPDATE CLIENTE
            SET IDCLIEATIV        = 'N',
                IDCLINADIMPLENTE  = 'S'
          WHERE CDCLIENTE   = C_CLIENTE_INAD.CDCLIENTE
            AND IDCLIEATIV = 'S';
      END LOOP;
   END IF;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VERIFICA_INADIMPLENCIA','5.67.XXX'); END;
/

