/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3932_CDPSTPO.SQL

Descrio:
Calcula periodicidade de produo para ms ou para ano.

P_CDFILIAL     - Cdigo da Filial.
P_CDPERIPRODU  - Cdigo da Periodicidade de Produo.
P_DTINICIAL    - Data inicial a ser gerado o clculo.
P_DTPROCESSA   - Data de Processamento da Filial.
P_NRMESES      - Nmero de Meses.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
06/09/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'CALCULA_PERIPRODUCAO' AND type = 'P')
   DROP PROCEDURE CALCULA_PERIPRODUCAO
   GO

CREATE PROCEDURE CALCULA_PERIPRODUCAO
   @P_CDFILIAL        VARCHAR(4),
   @P_CDPERIPRODU     VARCHAR(2),
   @P_DTINICIAL       DATETIME,
   @P_NRMESES         INT,
   @P_DTPROCESSA      DATETIME
AS
   DECLARE @V_CONTAMES    INT;
   DECLARE @V_IDTIPODIA   VARCHAR(1);
   DECLARE @V_IDDIANUTIL  VARCHAR(1);
   DECLARE @V_DTINIAUX    DATETIME;
BEGIN
   SET @V_IDTIPODIA  = NULL;
   SET @V_IDDIANUTIL = NULL;

   SELECT
      @V_IDTIPODIA  = MAX(IDTIPODIAP),
      @V_IDDIANUTIL = MAX(IDDIANUTILP)
   FROM
      PERIPRODUCAO
   WHERE
      (CDPERIPRODU = @P_CDPERIPRODU);

   SET @V_DTINIAUX = @P_DTINICIAL;

   SET @V_CONTAMES = 1;
   WHILE (@V_CONTAMES <= @P_NRMESES) BEGIN
      DELETE FROM CALEPRODUCAO
      WHERE
         (CDFILIAL          = @P_CDFILIAL)        AND
         (CDPERIPRODU       = @P_CDPERIPRODU)     AND
         (MONTH(DTPRODUCAO) = MONTH(@V_DTINIAUX)) AND
         (YEAR(DTPRODUCAO)  = YEAR(@V_DTINIAUX))  AND
         (DTPRODUCAO       >= @P_DTPROCESSA);

      IF @V_IDTIPODIA = 'S' BEGIN
         EXEC PERIPRODUCAO_SEMANAL @P_CDFILIAL,@P_CDPERIPRODU,@V_DTINIAUX,@V_IDDIANUTIL,@P_DTPROCESSA;
      END
      ELSE BEGIN
         EXEC PERIPRODUCAO_MENSAL @P_CDFILIAL,@P_CDPERIPRODU,@V_DTINIAUX,@V_IDDIANUTIL,@P_DTPROCESSA;
      END;

      SET @V_DTINIAUX = DATEADD(MM, 1, @V_DTINIAUX) - DAY(DATEADD(MM, 1, @V_DTINIAUX)) + 1;

      SET @V_CONTAMES = @V_CONTAMES + 1;
   END;
END
GO